|
@@ -0,0 +1,113 @@
|
|
1
|
+#!/bin/bash
|
|
2
|
+#
|
|
3
|
+# .---. . .
|
|
4
|
+# | | |
|
|
5
|
+# |--- .--. .-. .-. .-.| .-. .--.--. |.-. .-. .--. .-.
|
|
6
|
+# | | (.-' (.-' ( | ( )| | | | )( )| | (.-'
|
|
7
|
+# ' ' --' --' -' - -' ' ' -' -' -' ' - --'
|
|
8
|
+#
|
|
9
|
+# Freedom in the Cloud
|
|
10
|
+#
|
|
11
|
+# Functions for selecting which apps to install or remove
|
|
12
|
+#
|
|
13
|
+# License
|
|
14
|
+# =======
|
|
15
|
+#
|
|
16
|
+# Copyright (C) 2015-2016 Bob Mottram <bob@robotics.uk.to>
|
|
17
|
+#
|
|
18
|
+# This program is free software: you can redistribute it and/or modify
|
|
19
|
+# it under the terms of the GNU Affero General Public License as published by
|
|
20
|
+# the Free Software Foundation, either version 3 of the License, or
|
|
21
|
+# (at your option) any later version.
|
|
22
|
+#
|
|
23
|
+# This program is distributed in the hope that it will be useful,
|
|
24
|
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
|
|
25
|
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
|
|
26
|
+# GNU Affero General Public License for more details.
|
|
27
|
+#
|
|
28
|
+# You should have received a copy of the GNU Affero General Public License
|
|
29
|
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
|
|
30
|
+
|
|
31
|
+# Array containing names of available apps
|
|
32
|
+APPS_AVAILABLE=()
|
|
33
|
+
|
|
34
|
+# Array containing 1 or 0 indicating installed apps
|
|
35
|
+APPS_INSTALLED=()
|
|
36
|
+
|
|
37
|
+# Apps selected with checklist
|
|
38
|
+APPS_CHOSEN=()
|
|
39
|
+
|
|
40
|
+function item_in_array {
|
|
41
|
+ local e
|
|
42
|
+ for e in "${@:2}"; do [[ "$e" == "$1" ]] && return 0; done
|
|
43
|
+ return 1
|
|
44
|
+}
|
|
45
|
+
|
|
46
|
+function app_is_installed {
|
|
47
|
+ app_name="$1"
|
|
48
|
+ if [ ! -f $COMPLETION_FILE ]; then
|
|
49
|
+ echo "0"
|
|
50
|
+ return
|
|
51
|
+ fi
|
|
52
|
+
|
|
53
|
+ if ! grep -Fxq "install_${app_name}" $COMPLETION_FILE; then
|
|
54
|
+ echo "0"
|
|
55
|
+ else
|
|
56
|
+ echo "1"
|
|
57
|
+ fi
|
|
58
|
+}
|
|
59
|
+
|
|
60
|
+function get_apps_installed {
|
|
61
|
+ for a in "${APPS_AVAILABLE[@]}"
|
|
62
|
+ do
|
|
63
|
+ APPS_INSTALLED+=("$(app_is_installed $a)")
|
|
64
|
+ done
|
|
65
|
+}
|
|
66
|
+
|
|
67
|
+function detect_apps {
|
|
68
|
+ FILES=$PROJECT_INSTALL_DIR/${PROJECT_NAME}-app-*
|
|
69
|
+
|
|
70
|
+ APPS_AVAILABLE=()
|
|
71
|
+ APPS_CHOSEN=()
|
|
72
|
+
|
|
73
|
+ # for all the app scripts
|
|
74
|
+ for filename in $FILES
|
|
75
|
+ do
|
|
76
|
+ app_name=$(echo "${filename}" | awk -F '-app-' '{print $2}')
|
|
77
|
+ if [[ $(item_in_array ${app_name} ${APPS_AVAILABLE[@]}) != 0 ]]; then
|
|
78
|
+ APPS_AVAILABLE+=("${app_name}")
|
|
79
|
+ APPS_CHOSEN+=("0")
|
|
80
|
+ fi
|
|
81
|
+ done
|
|
82
|
+ get_apps_installed
|
|
83
|
+}
|
|
84
|
+
|
|
85
|
+function remove_apps {
|
|
86
|
+ app_index=0
|
|
87
|
+ for a in "${APPS_AVAILABLE[@]}"
|
|
88
|
+ do
|
|
89
|
+ if [[ ${APPS_INSTALLED[$app_index]} == "1" ]]; then
|
|
90
|
+ if [[ ${APPS_CHOSEN[$app_index]} == "0" ]]; then
|
|
91
|
+ echo $"Removing application: ${a}"
|
|
92
|
+ remove_${a}
|
|
93
|
+ echo $"${a} was removed"
|
|
94
|
+ fi
|
|
95
|
+ fi
|
|
96
|
+ app_index=$[app_index+1]
|
|
97
|
+ done
|
|
98
|
+}
|
|
99
|
+
|
|
100
|
+function install_apps {
|
|
101
|
+ app_index=0
|
|
102
|
+ for a in "${APPS_AVAILABLE[@]}"
|
|
103
|
+ do
|
|
104
|
+ if [[ ${APPS_INSTALLED[$app_index]} == "0" ]]; then
|
|
105
|
+ if [[ ${APPS_CHOSEN[$app_index]} == "1" ]]; then
|
|
106
|
+ echo $"Installing application: ${a}"
|
|
107
|
+ install_${a}
|
|
108
|
+ echo $"${a} was installed"
|
|
109
|
+ fi
|
|
110
|
+ fi
|
|
111
|
+ app_index=$[app_index+1]
|
|
112
|
+ done
|
|
113
|
+}
|